<script>
import ToolTemplate from "../../../../src/modules/tools/ToolTemplate.vue";
import {mapGetters, mapMutations, mapActions} from "vuex";
import getters from "../store/gettersDipasStorySelector";
import mutations from "../store/mutationsDipasStorySelector";
import axios from "axios";

export default {
    name: "DipasStorySelector",
    components: {
        ToolTemplate
    },
    data () {
        return {
            baseURL: "",
            proceedingname: "",
            proceedingurl: "",
            stories: []
        };
    },
    computed: {
        ...mapGetters("Tools/DipasStorySelector", Object.keys(getters))
    },
    async created () {

        await this.fetchDataFromUrl(this.$store.state.Tools.DipasStorySelector.storyIndexURL)
            .then(data => {
                this.baseURL = data.storybaseurl;
                this.proceedingname = data.proceedingname;
                this.proceedingurl = data.proceedingurl;
                this.stories = data.stories;
            });

        this.$on("close", this.close);
    },
    methods: {
        ...mapMutations("Tools/DipasStorySelector", Object.keys(mutations)),
        ...mapActions("Maps", ["registerListener", "unregisterListener"]),

        /**
         * Closes this tool window by setting active to false
         * @returns {void}
         */
        close () {
            this.setActive(false);

            const model = Radio.request("ModelList", "getModelByAttributes", {id: this.$store.state.Tools.DipasStorySelector.id});

            if (model) {
                model.set("isActive", false);
            }
        },
        /**
         * Returns the data from a url
         *
         * @param {String} url the path of the stories JSON
         * @returns {Object} response data of all stories
         */
        fetchDataFromUrl (url) {
            return axios
                .get(url)
                .then(response => response.data);
        }
    }
};
</script>

<template lang="html">
    <ToolTemplate
        :title="$t(name)"
        :icon="icon"
        :active="active"
        :render-to-window="renderToWindow"
        :resizable-window="resizableWindow"
        :deactivate-gfi="deactivateGFI"
    >
        <template #toolBody>
            <div
                v-if="active"
                id="tool-dipas-story-selector"
            >
                <h1> Dipas Stories </h1>
                <h2>
                    <a :href="proceedingurl + '/' + proceedingname">
                        {{ proceedingname }}
                    </a>
                </h2>

                <div class="list-group">
                    <a
                        v-for="(story) in stories"
                        :key="story.nid"
                        :href="baseURL + story.nid"
                        class="list-group-item list-group-item-action flex-column align-items-start story-box mb-2"
                    >
                        <div class="d-flex w-100 justify-content-between">

                            <img
                                class="col-md-4 title-image"
                                :src="story.titleimage"
                                alt="story image"
                            >
                            <div class="col-md-8 storydescription">
                                <h3> {{ story.title }} </h3>
                                <p class="mb-1 abstract"> {{ story.abstract }} </p>
                                <small class="reading-time">
                                    {{ $t('additional:modules.tools.dipasStorySelector.readingtime')
                                        + ': ' + story.reading_time }}
                                    {{ $t('additional:modules.tools.dipasStorySelector.timeunits') }}
                                </small>
                            </div>
                        </div>
                    </a>
                </div>
                <!--<span class="bootstrap-icon">
                    <i class="bi-x-circle-fill" />
                </span>-->
            </div>
        </template>
    </ToolTemplate>
</template>

<style lang="scss" scoped>
    #tool-dipas-story-selector {

        h1 {
            margin-bottom: 20px;
        }

        h2 {
            margin-bottom: 10px;
        }

        h3 {
            border-bottom: none;
            font-size: 20px;
            line-height: 35px;
            margin: 0;
            padding: 0;
        }

        p.abstract {
            font-size: 16px;
            white-space: pre-line;
            padding-bottom: 15px;
            max-height: 200px;
            overflow-y: auto;
        }

        /*a {
            margin-bottom: 10px;
        }*/

        .story-box {
            box-shadow: 1px 2px lightgrey;

            .title-image {
                object-fit: cover;
            }

            .storydescription {
                margin-left: 10px;
            }

            .reading-time {
                position: absolute;
                bottom: 5px;
            }
        }

        i.bi-x-circle-fill::before {
            color: grey;
            font-size: 1.5rem;
        }

        /*.story-box:hover {
            border-color: rgb(211, 211, 208);
            background-color: rgb(255, 255, 228);
        }*/
    }
</style>
